MsgBox "Program for printer firmware update over LAN connection" & vbCr & vbCr & "for Bell-Mark Printers", vbOKOnly, "Firmware Update"

'filename of the flash update file is
Dim sFUFilename : sFUFilename = "fl_bm.prn"

'default IP Address is
Dim sIPAddress : sIPAddress = "10.102.1.192"

On Error Resume Next
Dim bErrFlag

Dim iProgress
Const iCheckingSourceFilename = 0
Const iAttemptingToPing = 1
Const iAttemptingToFlash = 2

Dim fso : Set fso = CreateObject("Scripting.FileSystemObject")

'find the name of the file for flash updating in the current directory
iProgress = 0
If fso.FileExists(sFUFilename) Then
   'prompt User for IP Address
   sIPAddress=InputBox("Enter IP Address" & vbCR & vbCR & "...click OK to proceed with ping test","Bell-Mark Firmware Update",sIPAddress)
   iProgress = 1
   If Len(sIPAddress)>6 then
      'enter here with some kind of User response for IP address
      Dim objShell : set objShell = CreateObject("WScript.Shell")

      'ping the printer
      objShell.Run "ping "& sIPAddress
      Dim Return : Return = MsgBox("Was ping successful?", vbYesNo+vbQuestion, "Ping Test")
      If Return = vbYes Then
         'enter here if User said ping was OK
         'enter here to send source file to printer using DOS lpr command
         iProgress = 2
         Return = objShell.Run ("lpr -S" & sIPAddress & " -Pj " & sFUFilename, 2)
         'did the operation raise an error?
         If Err=0 then
            'display a popup
            'Dim strMessage : strMessage = "...sending " & sFUFilename & " to " & sIPAddress & Chr(13) & "Wait until printer reboots."
            Dim strMessage : strMessage = "The firmware is being sent."
            'Number of seconds in the delay
            Dim intWaitSeconds : intWaitSeconds = 10
            'Mesage Box Title
            Dim strTitle : strTitle = "...flashing"
            'Display Message Box PopUp for delay period and capture return value.
            Return = objShell.Popup(strMessage, intWaitSeconds, strTitle, 64)
         Else
            'enter here if lpr raised an error
            bErrFlag = 1
         End If
      Else
         'enter here if the User said the ping was not successful
          bErrFlag = 1
      End if
   Else
      'enter here if the User input was less than 7 characters (1.1.1.1)
      'or the User clicked Cancel (zero characters)
      'just let the program run out through to the end
   End if
Else
   'enter here if source file doesn't exist in the current directory
   bErrFlag = 1
End If

'Set fso = Nothing
'Set objShell = Nothing

If bErrFlag = 1 then
   'enter here if any error occured
   Dim sErrMsg
   If iProgress = 0 then
      'enter here if an error occurred during check file existence
      'the source file was not found
      sErrMsg = "Flash Update file " & sFUFilename & " not found!"
   ElseIf iProgress = 1 then
      'enter here if the user clicked the ping was not successful
      sErrMsg = "Ping failed"
   ElseIf iProgress = 2 then
      'enter here if LPR threw an error
      sErrMsg = "Flash update failed"
   End If
   'display message
   WScript.Echo(sErrMsg)
End If

'WScript.Quit(1)

